// Generated by LiveScript 1.5.0
var async, EventEmitter, path, filter, ServiceTester, AppTester;
async = require('async');
EventEmitter = require('events').EventEmitter;
path = require('path');
filter = require('prelude-ls').filter;
ServiceTester = require('./service-tester');
AppTester = (function(superclass){
  var prototype = extend$((import$(AppTester, superclass).displayName = 'AppTester', AppTester), superclass).prototype, constructor = AppTester;
  function AppTester(arg$){
    this.appConfig = arg$.appConfig, this.logger = arg$.logger;
  }
  AppTester.prototype.startTesting = function(){
    var protectionLevel, serviceRole, ref$, serviceData, i$, len$, service, _, tester, this$ = this;
    this.services = [];
    for (protectionLevel in this.appConfig.services) {
      for (serviceRole in ref$ = this.appConfig.services[protectionLevel]) {
        serviceData = ref$[serviceRole];
        this.services.push({
          role: serviceRole,
          location: serviceData.location
        });
      }
    }
    this.testers = {};
    for (i$ = 0, len$ = (ref$ = this.services).length; i$ < len$; ++i$) {
      service = ref$[i$];
      this.testers[service.role] = new ServiceTester({
        role: service.role,
        config: {
          root: path.join(process.cwd(), service.location),
          appName: this.appConfig.name
        },
        logger: this.logger
      });
    }
    return async.series((function(){
      var ref$, results$ = [];
      for (_ in ref$ = this.testers) {
        tester = ref$[_];
        results$.push(tester.start);
      }
      return results$;
    }.call(this)), function(err, exitCodes){
      switch (false) {
      case !err:
        this$.logger.log({
          role: 'exo-test',
          text: 'Tests failed'
        });
        return process.exit(1);
      case !this$._containsNonZero(exitCodes):
        this$.logger.log({
          role: 'exo-test',
          text: 'Tests failed'
        });
        return process.exit(1);
      default:
        return this$.logger.log({
          role: 'exo-test',
          text: 'All tests passed'
        });
      }
    });
  };
  AppTester.prototype._containsNonZero = function(exitCodes){
    var this$ = this;
    return exitCodes.filter((function(it){
      return it > 0;
    })).length > 0;
  };
  return AppTester;
}(EventEmitter));
module.exports = AppTester;
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}