// Generated by LiveScript 1.5.0
var async, EventEmitter, ref$, callArgs, DockerHelper, fs, yaml, ObservableProcess, path, wait, ServiceTester;
async = require('async');
EventEmitter = require('events').EventEmitter;
ref$ = require('../../exosphere-shared'), callArgs = ref$.callArgs, DockerHelper = ref$.DockerHelper;
fs = require('fs');
yaml = require('js-yaml');
ObservableProcess = require('observable-process');
path = require('path');
wait = require('wait').wait;
ServiceTester = (function(superclass){
  var prototype = extend$((import$(ServiceTester, superclass).displayName = 'ServiceTester', ServiceTester), superclass).prototype, constructor = ServiceTester;
  function ServiceTester(arg$){
    this.role = arg$.role, this.config = arg$.config, this.logger = arg$.logger;
    this.write = bind$(this, 'write', prototype);
    this._startDependencies = bind$(this, '_startDependencies', prototype);
    this.removeDependencies = bind$(this, 'removeDependencies', prototype);
    this.start = bind$(this, 'start', prototype);
    this.serviceConfig = yaml.safeLoad(fs.readFileSync(path.join(this.config.root, 'service.yml'), 'utf8'));
  }
  ServiceTester.prototype.start = function(done){
    var this$ = this;
    if (!this.serviceConfig.tests) {
      this.logger.log({
        role: 'exo-test',
        text: this.role + " has no tests, skipping"
      });
      return typeof done == 'function' ? done() : void 8;
    }
    return this._startDependencies(function(err){
      var x$;
      switch (false) {
      case !err:
        this$.logger.log({
          role: 'exo-test',
          text: "Error: " + err
        });
        return typeof done == 'function' ? done(err, 1) : void 8;
      }
      x$ = new ObservableProcess(callArgs(this$._createCommand(this$.serviceConfig.tests)), {
        cwd: this$.config.root,
        env: this$.config,
        stdout: {
          write: this$.write
        },
        stderr: {
          write: this$.write
        }
      });
      x$.on('ended', function(exitCode){
        if (exitCode > 0) {
          this$.logger.log({
            role: 'exo-test',
            text: this$.role + " is broken"
          });
        } else {
          this$.logger.log({
            role: 'exo-test',
            text: this$.role + " works"
          });
        }
        this$.removeDependencies();
        return typeof done == 'function' ? done(null, exitCode) : void 8;
      });
      return x$;
    });
  };
  ServiceTester.prototype.removeDependencies = function(){
    var dep, results$ = [];
    for (dep in this.serviceConfig.dependencies) {
      results$.push(DockerHelper.removeContainer("test-" + dep));
    }
    return results$;
  };
  ServiceTester.prototype._startDependencies = function(done){
    var dependencies, dependencyName, ref$, dependencyConfig, ref1$, this$ = this;
    dependencies = [];
    for (dependencyName in ref$ = this.serviceConfig.dependencies) {
      dependencyConfig = ref$[dependencyName];
      dependencies.push({
        containerName: "test-" + dependencyName,
        port: '-p 27017:27017',
        dependencyName: dependencyName,
        onlineText: (ref1$ = dependencyConfig.docker_flags) != null ? ref1$.online_text : void 8
      });
    }
    return async.eachSeries(dependencies, DockerHelper.ensureContainerIsRunning, function(err){
      switch (false) {
      case !err:
        done(err);
      }
      return done();
    });
  };
  ServiceTester.prototype._createCommand = function(command){
    if (this._isLocalCommand(command)) {
      command = path.join(this.config.root, command);
    }
    return command;
  };
  ServiceTester.prototype._isLocalCommand = function(command){
    return command.substr(0, 2) === './';
  };
  ServiceTester.prototype.write = function(text){
    return this.logger.log({
      role: this.role,
      text: text
    });
  };
  return ServiceTester;
}(EventEmitter));
module.exports = ServiceTester;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}